"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Arg = void 0;
const __1 = require("../..");
const GQLField_1 = require("./GQLField");
class Arg extends GQLField_1.GQLField {
    constructor(name, type) {
        super(name, type);
    }
    get type() {
        return this._type;
    }
    static create(nameOrField, type) {
        if (typeof nameOrField === "string") {
            return new Arg(nameOrField, type);
        }
        else if (nameOrField instanceof GQLField_1.GQLField) {
            return Arg.create(nameOrField.name, nameOrField.type)
                .setDescription(nameOrField.description)
                .setMeta(nameOrField.meta)
                .setDeprecationReason(nameOrField.deprecationReason);
        }
    }
    build() {
        return {
            name: this._name,
            type: __1.TypeParser.parse(this._type, __1.Schema.config.requiredByDefault),
            description: this._description,
            defaultValue: this._defaultValue,
            astNode: undefined,
            extensions: [],
        };
    }
}
exports.Arg = Arg;
//# sourceMappingURL=Arg.js.map